.586
.model flat,stdcall
option casemap:none

   include windows.inc
   include user32.inc
   include kernel32.inc
   include testTimeControl.inc
   include gdi32.inc
   include \masm32\macros\macros.asm
   
   includelib user32.lib
   includelib kernel32.lib
   includelib gdi32.lib
    
   include debug.inc   
   includelib debug.lib


	WinMain 		proto :DWORD,:DWORD,:DWORD,:DWORD
	controlProc 	proto :DWORD,:DWORD,:DWORD,:DWORD

.data
   ClassName 		db "MainWinClass",0
   AppName  		db "Main Window",0
   EditClassName 	db "edit",0
   tClassName 		db "win32asmTimeClass",0

.data?
   hInstance HINSTANCE ?
   CommandLine LPSTR ?
	oldButtonProc	dd ?
	hContainer		dd ?
	hdays			dd ?
	hhours			dd ?
	hmins			dd ?
	hSeconds		dd ?
	hMilli			dd ?

.code


; ---------------------------------------------------------------------------


start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	push  hInstance
	pop   wc.hInstance
	mov   eax,NULL
	mov   wc.cbClsExtra,eax
	mov   wc.cbWndExtra,eax
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,eax
	mov   wc.lpszClassName,OFFSET ClassName	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax	
	invoke LoadCursor,NULL,IDC_ARROW	
	mov   wc.hCursor,eax	
	invoke RegisterClassEx, addr wc
	
	CreateTimeClass hInst
	
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		invoke CreateWindowEx, NULL , offset tClassName,NULL, WS_CHILD or WS_VISIBLE , 100, 100, 100, 26, hWnd, NULL, hInstance, NULL
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF	
	xor eax,eax
	ret
WndProc endp

controlProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;	LOCAL createSt:CREATESTRUCT
	mov		eax,uMsg
	.IF eax==WM_CREATE
;		assume esi:PTR  CREATESTRUCT
		mov hContainer,$invoke(CreateWindowEx, WS_EX_CLIENTEDGE, CADD("EDIT"), NULL,WS_DISABLED or WS_TABSTOP or SS_WHITERECT or  WS_CHILD or WS_VISIBLE , 0, 0, 84, 26, hWnd, NULL, hInstance, NULL)		
		mov hhours,$invoke(CreateWindowEx,NULL, CADD("Edit"), CADD("00"), WS_TABSTOP or WS_CHILD or WS_VISIBLE, 2, 2, 18, 20, hWnd, NULL, hInstance, NULL)
		invoke      CreateWindowEx, NULL, CADD("Static"), CADD(":"), WS_CHILD or WS_VISIBLE, 18, 2, 4, 20, hWnd, NULL, hInstance, NULL
		mov hmins, $invoke(CreateWindowEx, NULL, CADD("Edit"), CADD("00"), WS_TABSTOP or WS_CHILD or WS_VISIBLE, 22, 2, 16, 20, hWnd, NULL, hInstance, NULL)
		invoke      CreateWindowEx, NULL, CADD("Static"), CADD(":"), WS_CHILD or WS_VISIBLE, 38, 2, 4, 20, hWnd, NULL, hInstance, NULL
		mov hSeconds ,$invoke(CreateWindowEx, NULL, CADD("Edit"), CADD("00"), WS_TABSTOP or WS_CHILD or WS_VISIBLE, 42, 2, 20, 20, hWnd, NULL, hInstance, NULL)
		invoke      CreateWindowEx, NULL, CADD("Static"), CADD("."), WS_CHILD or WS_VISIBLE, 58, 2, 4, 20, hWnd, NULL, hInstance, NULL
		mov hMilli ,$invoke(CreateWindowEx, NULL, CADD("Edit"), CADD("00"), WS_TABSTOP or WS_CHILD or WS_VISIBLE, 62, 2, 20, 20, hWnd, NULL, hInstance, NULL)
;		assume esi:nothing
		xor eax,eax
	.elseif ( eax==WM_CTLCOLORSTATIC )
		invoke SetBkColor, [wParam],00FFFFFFh
		invoke SetTextColor, [wParam], 00000000h
		invoke CreateSolidBrush,00FFFFFFh
	.elseif ( eax==WM_CTLCOLOREDIT )
		invoke SetBkColor, [wParam], 00FFFFFFh
		invoke SetTextColor, [wParam], 00000000h
		invoke CreateSolidBrush,00FFFFFFh
	.ELSEIF eax==WM_DESTROY
		invoke DestroyWindow,hContainer
		invoke DestroyWindow,hhours
		invoke DestroyWindow,hmins
		invoke DestroyWindow,hSeconds
		invoke DestroyWindow,hMilli
		xor eax,eax
	.ELSE
		invoke DefWindowProc,hWnd, uMsg, wParam, lParam 
	.ENDIF
	ret
controlProc endp
end start
